"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _components = require("../components");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ArrayBulkField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(ArrayBulkField, _Component);

	function ArrayBulkField(props) {
		(0, _classCallCheck3.default)(this, ArrayBulkField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (ArrayBulkField.__proto__ || (0, _getPrototypeOf2.default)(ArrayBulkField)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = (0, _extends3.default)({ rowAmount: 0 }, _this.getStateFromProps(props));
		return _this;
	}

	(0, _createClass3.default)(ArrayBulkField, [{
		key: "render",
		value: function render() {
			var TitleField = this.props.registry.fields.TitleField;

			return _react2.default.createElement(
				"fieldset",
				null,
				_react2.default.createElement(TitleField, { title: this.props.schema.title || this.props.name, className: (0, _utils.getUiOptions)(this.props.uiSchema).titleClassName }),
				this.renderItems(),
				_react2.default.createElement(
					_components.Button,
					{ onClick: this.onAddClick },
					"Lis\xE4\xE4 havaintorivej\xE4"
				),
				_react2.default.createElement("br", null)
			);
		}
	}]);
	return ArrayBulkField;
}(_react.Component)) || _class;

ArrayBulkField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			rowAddAmount: _propTypes2.default.number
		})
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array.isRequired
};

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.getStateFromProps = function (props) {
		var state = {};

		var _getUiOptions = (0, _utils.getUiOptions)(props.uiSchema),
		    rowAddAmount = _getUiOptions.rowAddAmount;

		state.rowAddAmount = 10;
		if (rowAddAmount > 0) state.rowAddAmount = rowAddAmount;
		if (props.formData && props.formData.length > _this2.state.rowAmount) {
			state.rowAmount = props.formData.length + state.rowAddAmount - props.formData.length % state.rowAddAmount;
		}
		return state;
	};

	this.renderItems = function () {
		var rows = [];
		var idx = 0;
		var data = _this2.props.formData || [];

		while (data.length < _this2.state.rowAmount) {
			data.push({});
		}

		var SchemaField = _this2.props.registry.fields.SchemaField;
		if (data) data.forEach(function (item) {
			rows.push(_react2.default.createElement(SchemaField, {
				key: idx,
				formData: item,
				onChange: _this2.onChangeForIdx(idx),
				schema: _this2.props.schema.items,
				uiSchema: _this2.props.uiSchema.items,
				idSchema: { $id: _this2.props.idSchema.$id + "_" + idx },
				registry: _this2.props.registry,
				errorSchema: _this2.props.errorSchema[idx] }));
			idx++;
		});
		return rows;
	};

	this.onChangeForIdx = function (idx) {
		return function (itemFormData) {
			var formData = _this2.props.formData;
			if (!formData) formData = [];
			formData[idx] = itemFormData;
			_this2.props.onChange(formData.filter(function (item) {
				return (0, _keys2.default)(item).length;
			}));
		};
	};

	this.onAddClick = function (event) {
		event.preventDefault();
		_this2.setState({ rowAmount: _this2.state.rowAmount + _this2.state.rowAddAmount });
	};
};

exports.default = ArrayBulkField;