"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _utils = require("../../utils");

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO should work as widget also
var ImageDisplayField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(ImageDisplayField, _Component);

	function ImageDisplayField() {
		(0, _classCallCheck3.default)(this, ImageDisplayField);
		return (0, _possibleConstructorReturn3.default)(this, (ImageDisplayField.__proto__ || (0, _getPrototypeOf2.default)(ImageDisplayField)).apply(this, arguments));
	}

	(0, _createClass3.default)(ImageDisplayField, [{
		key: "render",
		value: function render() {
			var SchemaField = this.props.registry.fields.SchemaField;

			var uiSchema = (0, _utils.getInnerUiSchema)(this.props.uiSchema);

			var _getUiOptions = (0, _utils.getUiOptions)(this.props.uiSchema),
			    _getUiOptions$urls = _getUiOptions.urls,
			    urls = _getUiOptions$urls === undefined ? [] : _getUiOptions$urls,
			    _getUiOptions$buttons = _getUiOptions.buttons,
			    buttons = _getUiOptions$buttons === undefined ? [] : _getUiOptions$buttons;

			uiSchema = (0, _immutabilityHelper2.default)(uiSchema, { "ui:options": { buttons: { $set: [].concat((0, _toConsumableArray3.default)(buttons), [{ position: "left", render: function render() {
								return _react2.default.createElement(
									"div",
									{ className: "laji-form-medias", key: "image-display" },
									(Array.isArray(urls) ? urls : [urls]).map(function (url) {
										return _react2.default.createElement(
											"div",
											{ className: "media-container", key: url },
											_react2.default.createElement("img", { src: url })
										);
									})
								);
							}
						}]) } } });
			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, {
					uiSchema: uiSchema
				}))
			);
		}
	}]);
	return ImageDisplayField;
}(_react.Component)) || _class;

ImageDisplayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			urls: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.arrayOf(_propTypes2.default.string)]),
			buttons: _propTypes2.default.arrayOf(_propTypes2.default.string)
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array", "object"])
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object])
};
exports.default = ImageDisplayField;