"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("react-jsonschema-form/lib/utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PrefillingArrayField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(PrefillingArrayField, _Component);

	function PrefillingArrayField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, PrefillingArrayField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = PrefillingArrayField.__proto__ || (0, _getPrototypeOf2.default)(PrefillingArrayField)).call.apply(_ref, [this].concat(args))), _this), _this.mapFormData = function (formData) {
			var prefiller = formData.prefiller;
			return (formData.rest && formData.rest.length ? formData.rest : [(0, _utils.getDefaultFormState)(_this.props.schema.items, undefined, _this.props.registry.definitions)]).map(function (item) {
				return (0, _extends4.default)({}, item, (0, _defineProperty3.default)({}, _this.getUiOptions().field, prefiller));
			});
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(PrefillingArrayField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _getUiOptions = this.getUiOptions(),
			    field = _getUiOptions.field,
			    uiSchema = _getUiOptions.uiSchema;

			return (0, _extends4.default)({}, props, {
				schema: {
					type: "object",
					title: "",
					properties: {
						prefiller: props.schema.items.properties[field],
						rest: props.schema
					}
				},
				uiSchema: {
					prefiller: uiSchema || props.uiSchema.items[field],
					rest: props.formData && props.formData.length ? props.uiSchema : (0, _extends4.default)({}, props.uiSchema, {
						"ui:options": (0, _extends4.default)({}, props.uiSchema["ui:options"], {
							canAdd: false
						})
					})
				},
				formData: {
					prefiller: ((props.formData || [])[0] || {})[field],
					rest: props.formData
				},
				idSchema: {
					prefiller: { prefiller: props.idSchema.$id + "_" + field },
					rest: props.idSchema
				}
			});
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			this.props.onChange(this.mapFormData(formData));
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "PrefillingArrayField";
		}
	}]);
	return PrefillingArrayField;
}(_react.Component)) || _class;

PrefillingArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			field: _propTypes2.default.string,
			uiSchema: _propTypes2.default.object
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array.isRequired
};
exports.default = PrefillingArrayField;