"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _LajiForm = require("./components/LajiForm");

var _LajiForm2 = _interopRequireDefault(_LajiForm);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LajiFormWrapper = function LajiFormWrapper(props) {
	var _this = this;

	(0, _classCallCheck3.default)(this, LajiFormWrapper);

	this.submit = function () {
		_this.app.refs.lajiform.submit();
	};

	this.setState = function (state) {
		_this.app && _this.app.setState(state);
	};

	this.pushBlockingLoader = function () {
		_this.app.refs.lajiform.pushBlockingLoader();
	};

	this.popBlockingLoader = function () {
		_this.app.refs.lajiform.popBlockingLoader();
	};

	this.getSettings = function () {
		return _this.app.refs.lajiform.getSettings();
	};

	this.destroy = function () {
		_this.app.refs.lajiform.destroy();
		(0, _reactDom.unmountComponentAtNode)(_this.rootElem);
	};

	this.unmount = this.destroy;

	this.invalidateSize = function () {
		var lajiForm = _this.app.refs.lajiform;
		var resize = lajiForm.customEventListeners.resize;


		(0, _keys2.default)(resize || {}).sort().reverse().forEach(function (id) {
			lajiForm._context.sendCustomEvent(id, "resize", undefined, undefined, { bubble: false });
		});
	};

	this.props = props;
	this.rootElem = props.rootElem;
	this.app = (0, _reactDom.render)(_react2.default.createElement(LajiFormApp, props), this.rootElem);
};

exports.default = LajiFormWrapper;

var LajiFormApp = function (_Component) {
	(0, _inherits3.default)(LajiFormApp, _Component);

	function LajiFormApp() {
		(0, _classCallCheck3.default)(this, LajiFormApp);
		return (0, _possibleConstructorReturn3.default)(this, (LajiFormApp.__proto__ || (0, _getPrototypeOf2.default)(LajiFormApp)).apply(this, arguments));
	}

	(0, _createClass3.default)(LajiFormApp, [{
		key: "render",
		value: function render() {
			return _react2.default.createElement(_LajiForm2.default, (0, _extends3.default)({}, this.props, this.state || {}, { ref: "lajiform" }));
		}
	}]);
	return LajiFormApp;
}(_react.Component);