"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("react-jsonschema-form/lib/utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

var _utils2 = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AutoArrayField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(AutoArrayField, _Component);

	function AutoArrayField() {
		(0, _classCallCheck3.default)(this, AutoArrayField);
		return (0, _possibleConstructorReturn3.default)(this, (AutoArrayField.__proto__ || (0, _getPrototypeOf2.default)(AutoArrayField)).apply(this, arguments));
	}

	(0, _createClass3.default)(AutoArrayField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _this2 = this;

			var _props$formData = props.formData,
			    formData = _props$formData === undefined ? [] : _props$formData,
			    schema = props.schema,
			    uiSchema = props.uiSchema,
			    registry = props.registry;


			var state = { formData: formData };

			var newEmptyItem = (0, _utils.getDefaultFormState)(schema.items, undefined, registry.definitions);
			var emptyItem = this.emptyItem && (0, _utils2.formDataEquals)(newEmptyItem, this.emptyItem, props.formContext, props.idSchema.$id) && formData.every(function (item) {
				return (0, _utils2.getUUID)(item) !== (0, _utils2.getUUID)(_this2.emptyItem);
			}) ? this.emptyItem : (0, _utils2.assignUUID)(newEmptyItem);
			this.emptyItem = emptyItem;
			if (formData && (formData.length === 0 || !(0, _utils2.formDataEquals)(formData[formData.length - 1], emptyItem, props.formContext, props.idSchema.$id))) {
				state.formData = [].concat((0, _toConsumableArray3.default)(formData), [emptyItem]);
			}
			state.uiSchema = (0, _extends3.default)({}, uiSchema, {
				"ui:options": (0, _extends3.default)({
					canAdd: false
				}, uiSchema["ui:options"] || {}, {
					nonOrderables: [state.formData.length - 1],
					nonRemovables: [state.formData.length - 1]
				})
			});

			return state;
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var emptyItem = (0, _utils.getDefaultFormState)(this.props.schema.items, undefined, this.props.registry.definitions);
			if (formData && formData.length !== 0 && (0, _utils2.formDataEquals)(formData[formData.length - 1], emptyItem, this.props.formContext, this.props.idSchema.$id)) {
				formData = formData.slice(0, formData.length - 1);
			}
			this.props.onChange(formData);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "AutoArrayField";
		}
	}]);
	return AutoArrayField;
}(_react.Component)) || _class;

AutoArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			autofocus: _propTypes2.default.boolean
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array
};
exports.default = AutoArrayField;