"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TaxonImageWidget = function (_Component) {
	(0, _inherits3.default)(TaxonImageWidget, _Component);

	function TaxonImageWidget() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, TaxonImageWidget);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = TaxonImageWidget.__proto__ || (0, _getPrototypeOf2.default)(TaxonImageWidget)).call.apply(_ref, [this].concat(args))), _this), _this.onTaxonImageClick = function (taxonID) {
			return function () {
				_this.props.onChange(taxonID);
			};
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(TaxonImageWidget, [{
		key: "render",
		value: function render() {
			var _this2 = this;

			var SchemaField = this.props.registry.fields.SchemaField;

			var _getUiOptions = (0, _utils.getUiOptions)(this.props),
			    uiSchema = _getUiOptions.uiSchema;

			var schemaField = uiSchema ? _react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, { schema: (0, _extends3.default)({}, this.props.schema, { title: "" }), uiSchema: (0, _extends3.default)({}, uiSchema, { "ui:title": "" }) })) : null;

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				["MX.45", "MX.255"].map(function (taxonID) {
					return _react2.default.createElement("div", { key: taxonID, style: { height: 100, width: 100 }, onClick: _this2.onTaxonImageClick(taxonID) });
				}),
				schemaField
			);
		}
	}]);
	return TaxonImageWidget;
}(_react.Component);

TaxonImageWidget.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}).isRequired,
	value: _propTypes2.default.string
};
exports.default = TaxonImageWidget;