"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var URLWidget = function URLWidget(_ref) {
	var value = _ref.value;
	return _react2.default.createElement(
		"a",
		{ href: value, target: "_blank", rel: "noopener noreferrer" },
		value
	);
};
URLWidget.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}),
	value: _propTypes2.default.string
};
exports.default = URLWidget;